#!/usr/bin/env python3
# -*- python -*-

# Import required modules
import csv
import sqlite3
import os
import pwd
import vobject
import sys

database_path = os.path.expanduser( '~/.local/share/linphone/friends.db' )
 
# Connecting to the geeks database
connection = sqlite3.connect(database_path)
 
# Creating a cursor object to execute
# SQL queries on a database table
cursor = connection.cursor()
 
# Table Definition
# create_table = '''CREATE TABLE friends(
#    id INTEGER PRIMARY KEY AUTOINCREMENT,
#    friend_list_id INTEGER,
#    sip_uri TEXT,
#    subscribe_policy INTEGER,
#    send_subscribe INTEGER,
#    ref_key TEXT,
#    vCard TEXT,
#    vCard_etag TEXT,
#    vCard_url TEXT,
#    presence_received INTEGER)
#    '''
 
# SQL query to insert data into the
# friends table
# insert_records = "INSERT INTO friends (friend_list_id, sip_uri, subscribe_policy, send_subscribe, ref_key, vCard, vCard_etag, vCard_url, presence_received) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?)"

tmpfile = "tmp.csv"
with open(sys.argv[1]) as inf:
    # Create a temporary CSV file which will be imported later
    indata = inf.read()
    vc = vobject.readComponents(indata)
    vo = next(vc, None)
    with open(tmpfile, "a") as file:
        # Create a temporary csv import file
        while vo is not None:
            print( f'1,"""{ vo.fn.value }"" <{ vo.impp.value }>",1,0,"{ vo.serialize() }",0', file=file)
            vo = next(vc, None)

# Opening the tmp.csv file
file = open(tmpfile)

# Reading the contents of the 
# person-records.csv file
contents = csv.reader(file)
 
# SQL query to insert data into the
# friends table
insert_records = "INSERT INTO friends (friend_list_id, sip_uri, subscribe_policy, send_subscribe, ref_key, vCard, vCard_etag, vCard_url, presence_received) VALUES(?, ?, ?, ?, NULL, ?, NULL, NULL, ?)"
 
# Importing the contents of the file 
# into our person table
cursor.executemany(insert_records, contents)

# Detect duplicates and remove them
delete_duplicates="DELETE FROM friends WHERE EXISTS (SELECT * FROM friends contacts WHERE friends.sip_uri = contacts.sip_uri AND friends.vCard = contacts.vCard AND friends.rowid > contacts.rowid)"
cursor.execute(delete_duplicates)

# If file exists, delete it.
if os.path.isfile(tmpfile):
    os.remove(tmpfile)
else:
    # If it fails, inform the user.
    print("Error: %s file not found" % tmpfile)

# SQL query to retrieve all data from
# the person table To verify that the
# data of the csv file has been successfully 
# inserted into the table
select_all = "SELECT * FROM friends"
rows = cursor.execute(select_all).fetchall()
 
# Output to the console screen
for r in rows:
    print(r)
 
# Committing the changes
connection.commit()
 
# closing the database connection
connection.close()
